open_crafting_table:
    type: command
    name: craft
    description: Opens the 5x5 crafting table
    usage: /craft
    permission: customcrafting.craftcommand
    script:
        - inventory open d:crafting_inventory

crafting_inventory:
    type: inventory
    inventory: chest
    title: Crafting Table
    debug: false
    size: 45
    slots:
        - [] [] [] [] [] [crafting_filler_item] [crafting_filler_item] [crafting_filler_item] [crafting_filler_item]
        - [] [] [] [] [] [crafting_filler_item] [crafting_filler_item] [crafting_filler_item] [crafting_filler_item]
        - [] [] [] [] [] [crafting_filler_item] [] [crafting_filler_item] [crafting_filler_item]
        - [] [] [] [] [] [crafting_filler_item] [crafting_filler_item] [crafting_filler_item] [crafting_filler_item]
        - [] [] [] [] [] [crafting_filler_item] [crafting_filler_item] [crafting_filler_item] [crafting_filler_item]

crafting_filler_item:
    type: item
    debug: false
    material: black_stained_glass_pane
    display name: " "

get_item_tag:
    type: command
    name: getitem
    description: Prints the item tag that you can put in recipes.dsc for custom recipes.
    usage: /getitem
    permission: customcrafting.getitem
    script:
        - define text "<&e>Click me to copy the item to your clipboard!"
        - narrate <[text].on_hover[Click!].on_click[item:<player.item_in_hand>].type[COPY_TO_CLIPBOARD]>

custom_crafting:
    type: world
    debug: false
    events:
        on player clicks crafting_filler_item in crafting_inventory:
            - determine cancelled:true
        on player clicks item in crafting_inventory slot:25:
            - if <context.action> == PLACE_ALL || <context.action> == PLACE_ONE || <context.action> == PLACE_SOME:
                - determine cancelled:true
            - if <context.action> == PICKUP_ALL || <context.action> == PICKUP_HALF || <context.action> == PICKUP_ONE || <context.action> == PICKUP_SOME || <context.action> == DROP_ALL_SLOT || <context.action> == DROP_ONE_SLOT || <context.action> == MOVE_TO_OTHER_INVENTORY || <context.action> == HOTBAR_SWAP:
                - inventory set d:<context.inventory> slot:1 o:<item[air]>
                - inventory set d:<context.inventory> slot:2 o:<item[air]>
                - inventory set d:<context.inventory> slot:3 o:<item[air]>
                - inventory set d:<context.inventory> slot:4 o:<item[air]>
                - inventory set d:<context.inventory> slot:5 o:<item[air]>
                - inventory set d:<context.inventory> slot:10 o:<item[air]>
                - inventory set d:<context.inventory> slot:11 o:<item[air]>
                - inventory set d:<context.inventory> slot:12 o:<item[air]>
                - inventory set d:<context.inventory> slot:13 o:<item[air]>
                - inventory set d:<context.inventory> slot:14 o:<item[air]>
                - inventory set d:<context.inventory> slot:19 o:<item[air]>
                - inventory set d:<context.inventory> slot:20 o:<item[air]>
                - inventory set d:<context.inventory> slot:21 o:<item[air]>
                - inventory set d:<context.inventory> slot:22 o:<item[air]>
                - inventory set d:<context.inventory> slot:23 o:<item[air]>
                - inventory set d:<context.inventory> slot:28 o:<item[air]>
                - inventory set d:<context.inventory> slot:29 o:<item[air]>
                - inventory set d:<context.inventory> slot:30 o:<item[air]>
                - inventory set d:<context.inventory> slot:31 o:<item[air]>
                - inventory set d:<context.inventory> slot:32 o:<item[air]>
                - inventory set d:<context.inventory> slot:37 o:<item[air]>
                - inventory set d:<context.inventory> slot:38 o:<item[air]>
                - inventory set d:<context.inventory> slot:39 o:<item[air]>
                - inventory set d:<context.inventory> slot:40 o:<item[air]>
                - inventory set d:<context.inventory> slot:41 o:<item[air]>
        on player drags item in crafting_inventory:
            - if <context.slots.contains[25]>:
                - determine cancelled:true
        on player closes crafting_inventory:
            - drop <context.inventory.slot[1]>
            - drop <context.inventory.slot[2]>
            - drop <context.inventory.slot[3]>
            - drop <context.inventory.slot[4]>
            - drop <context.inventory.slot[5]>
            - drop <context.inventory.slot[10]>
            - drop <context.inventory.slot[11]>
            - drop <context.inventory.slot[12]>
            - drop <context.inventory.slot[13]>
            - drop <context.inventory.slot[14]>
            - drop <context.inventory.slot[19]>
            - drop <context.inventory.slot[20]>
            - drop <context.inventory.slot[21]>
            - drop <context.inventory.slot[22]>
            - drop <context.inventory.slot[23]>
            - drop <context.inventory.slot[28]>
            - drop <context.inventory.slot[29]>
            - drop <context.inventory.slot[30]>
            - drop <context.inventory.slot[31]>
            - drop <context.inventory.slot[32]>
            - drop <context.inventory.slot[37]>
            - drop <context.inventory.slot[38]>
            - drop <context.inventory.slot[39]>
            - drop <context.inventory.slot[40]>
            - drop <context.inventory.slot[41]>
        after player clicks item in crafting_inventory:
            - run locally path:crafting_script def:<context.inventory>
        after player drags item in crafting_inventory:
            - run locally path:crafting_script def:<context.inventory>
    crafting_script:
        - define inv <[1]>
        - foreach <script[recipes].data_key[recipes]>:
            - if <player.has_permission[<[value].get[permission]>]>:
                - define slot 0
                - define empty_slots 4
                - define success yes
                - foreach <[value].get[recipe]>:
                    - foreach <[value].split[<&chr[007c]>]>:
                        - define current_item <[value]>
                        - define slot <[slot].add[1]>
                        - if <[current_item].split[<&chr[003a]>].size> == 1:
                            - define item_id air
                            - define item_amount 1
                        - else:
                            - define item_id <[current_item].split[<&chr[003a]>].get[1]>
                            - define item_amount <[current_item].split[<&chr[003a]>].get[2]>
                        - if <[item_id]> == flag:
                            - if !<[inv].slot[<[slot]>].has_flag[<[item_amount]>]> || <[inv].slot[<[slot]>].flag[<[item_amount]>]> != <[current_item].split[<&chr[003a]>].get[3]>:
                                - inventory set d:<[inv]> slot:25 o:<item[air]>
                                - define success no
                                - foreach stop
                        - else if <[item_id]> == item:
                            - define item <[current_item].split[<&chr[003a]>].limit[2].get[2]>
                            - if <[inv].slot[<[slot]>]> != <[item]>:
                                - inventory set d:<[inv]> slot:25 o:<item[air]>
                                - define success no
                                - foreach stop
                        - else if <[inv].slot[<[slot]>]> != <item[<[item_id]>].with[quantity=<[item_amount]>]>:
                            - inventory set d:<[inv]> slot:25 o:<item[air]>
                            - define success no
                            - foreach stop
                    - if <[success]> == no:
                        - foreach stop
                    - define slot <[slot].add[<[empty_slots]>]>
                - if <[success]> == yes:
                    - define result_item <[value].get[result].split[<&chr[003C]><&chr[0026]><&chr[0063]><&chr[006f]><&chr[003e]>]>
                    - if <[result_item].get[1]> == item:
                        - inventory set d:<[inv]> slot:25 o:<[result_item].get[2]>
                    - else:
                        - inventory set d:<[inv]> slot:25 o:<item[<[result_item].get[1]>].with[quantity=<[result_item].get[2]>]>
                    - foreach stop